class_name MobSpawner
extends Path2D
# Responsible of enemy life-cycle


signal reset

export (PackedScene) var Mob


func spawn():
	$MobSpawnLocation.set_offset(randi())
	var newRotation = $MobSpawnLocation.rotation + rand_range(PI / 4, 3 * PI / 4)

	var newMob = Mob.instance()
	newMob.rotation = newRotation
	newMob.position = $MobSpawnLocation.position
	newMob.linear_velocity = Vector2(rand_range(newMob.min_speed, newMob.max_speed), 0).rotated(newRotation)

	connect("reset", newMob, "_on_Spawner_reset")

	add_child(newMob)


func _on_MobTimer_timeout():
	spawn()
	$MobTimer.start()


func _on_HUD_start_game():
	emit_signal("reset")


func _on_Main_game_started():
	$MobTimer.start()


func _on_Main_game_over():
	$MobTimer.stop()
